import 'dart:html';
import '../lib/hqx_dart.dart';

void main() {

  CanvasElement canvas = querySelector("#canvas");
  CanvasRenderingContext2D context = canvas.getContext("2d");
  
  ImageElement image = new ImageElement(src: "mushroom.jpg");
  image.onLoad.listen((Event e){
    
    Hqx.init();
    draw1(image, 10, context);
    draw2(image, 10, context);
    draw3(image, 10, context);
    draw4(image, 10, context);
    
    image = new ImageElement(src: "mushroom.gif");
    image.onLoad.listen((Event e){
      
      draw1(image, 150, context);
      draw2(image, 150, context);
      draw3(image, 150, context);
      draw4(image, 150, context);
      
      image = new ImageElement(src: "mushroom.jpg");
      image.onLoad.listen((Event e){
        
        draw1(image, 300, context);
        draw2(image, 300, context);
        draw3(image, 300, context);
        draw4(image, 300, context);
        Hqx.deinit();
      });
    });
  });
}

void draw1(ImageElement image, int dY, CanvasRenderingContext2D context){
  context.drawImage(image, 10, dY);
}

void draw2(ImageElement image, int dY, CanvasRenderingContext2D context){
  
  ImageData source = Hqx.getPixels(image);
  ImageData destination = context.createImageData(image.width * 2, image.height * 2);
  Hqx.hq2x_32_rb_default(source, destination);
  context.putImageData(destination, 30, dY);
  
}

void draw3(ImageElement image, int dY, CanvasRenderingContext2D context){

  ImageData source = Hqx.getPixels(image);
  ImageData destination = context.createImageData(image.width * 3, image.height * 3);
  Hqx.hq3x_32_rb_default(source, destination);
  context.putImageData(destination, 70, dY);
}

void draw4(ImageElement image, int dY, CanvasRenderingContext2D context){

  ImageData source = Hqx.getPixels(image);
  ImageData destination = context.createImageData(image.width * 4, image.height * 4);
  Hqx.hq4x_32_rb_default(source, destination);
  context.putImageData(destination, 130, dY);
}